Index: tests/Joiner/BondFragment06/pcp.energy.all
===================================================================
--- tests/Joiner/BondFragment06/pcp.energy.all	(revision 88f62988b19f6b6b102c0be34eb40d8e219b8414)
+++ tests/Joiner/BondFragment06/pcp.energy.all	(revision 88f62988b19f6b6b102c0be34eb40d8e219b8414)
@@ -0,0 +1,2 @@
+Time		Total
+0.000000e+00	-39.9767391934
Index: tests/Joiner/BondFragment06/pcp.forces.all
===================================================================
--- tests/Joiner/BondFragment06/pcp.forces.all	(revision 88f62988b19f6b6b102c0be34eb40d8e219b8414)
+++ tests/Joiner/BondFragment06/pcp.forces.all	(revision 88f62988b19f6b6b102c0be34eb40d8e219b8414)
@@ -0,0 +1,121 @@
+Type	No		Pos0		Pos1		Pos2		Total0		Total1		Total2
+0	0	3.389954614	3.758700000	2.500000000	-0.0000016307	0.0029443434	-0.0041658316
+0	1	3.389954614	3.758700000	4.280000000	-0.0000016307	0.0029443434	0.0041658316
+0	2	4.279954614	2.500000000	3.390000000	0.0041893005	-0.0029737362	-0.0000000000
+0	3	2.500000000	2.500050506	3.390000000	-0.0041536141	-0.0029461076	0.0000000000
+1	0	3.389954614	3.129400000	3.390000000	-0.0000324249	0.0000311570	-0.0000000000
+MeanForce:	0.00409547537083
+0	0	3.389954614	3.758700000	2.500000000	-0.0000016307	0.0029443437	-0.0041658321
+0	1	3.389954614	3.758700000	4.280000000	-0.0000016307	0.0029443437	0.0041658321
+0	2	4.279954614	2.500000000	3.390000000	0.0041893010	-0.0029737366	0.0000000000
+0	3	2.500000000	2.500050506	3.390000000	-0.0041536146	-0.0029461079	0.0000000000
+1	0	3.389954614	3.129400000	3.390000000	-0.0000324249	0.0000311570	-0.0000000000
+MeanForce:	0.00409547584754
+0	0	3.389954614	3.758700000	2.500000000	-0.0003057474	0.0034947512	-0.0049839020
+0	1	3.389954614	3.758700000	4.280000000	-0.0003385929	0.0021845914	0.0029422656
+0	2	4.279954614	2.500000000	3.390000000	0.0053421138	-0.0040522754	-0.0001138824
+0	3	2.500000000	2.500050506	3.390000000	-0.0021004444	-0.0013043225	-0.0000752240
+1	0	3.389954614	3.129400000	3.390000000	-0.0025973290	-0.0003227447	0.0022307428
+MeanForce:	0.00447873641544
+0	0	3.389954614	3.758700000	2.500000000	-0.0000236133	0.0043572154	-0.0052876038
+0	1	3.389954614	3.758700000	4.280000000	-0.0002175344	0.0024956824	0.0028429713
+0	2	4.279954614	2.500000000	3.390000000	0.0044747420	-0.0034870914	-0.0000080402
+0	3	2.500000000	2.500050506	3.390000000	-0.0058334128	-0.0042764112	0.0001890478
+1	0	3.389954614	3.129400000	3.390000000	0.0015998185	0.0009106047	0.0022636250
+MeanForce:	0.0052933963535
+0	0	3.389954614	3.758700000	2.500000000	-0.0001565459	0.0024190051	-0.0026598852
+0	1	3.389954614	3.758700000	4.280000000	-0.0003537651	0.0032190019	0.0038572218
+0	2	4.279954614	2.500000000	3.390000000	0.0020592006	-0.0012257304	-0.0000618501
+0	3	2.500000000	2.500050506	3.390000000	-0.0043524492	-0.0024822371	0.0001334704
+1	0	3.389954614	3.129400000	3.390000000	0.0028035596	-0.0019300395	-0.0012689569
+MeanForce:	0.0039354354553
+0	0	3.389954614	3.758700000	2.500000000	0.0001037937	0.0033031526	-0.0049508758
+0	1	3.389954614	3.758700000	4.280000000	0.0001889488	0.0012998844	0.0025681437
+0	2	4.279954614	2.500000000	3.390000000	0.0047034766	-0.0026774660	0.0002719545
+0	3	2.500000000	2.500050506	3.390000000	-0.0043626111	-0.0026452458	0.0001839924
+1	0	3.389954614	3.129400000	3.390000000	-0.0006336080	0.0007196748	0.0019267852
+MeanForce:	0.00430270773415
+0	0	3.389954614	3.758700000	2.500000000	-0.0000990642	0.0017135027	-0.0024782553
+0	1	3.389954614	3.758700000	4.280000000	0.0000002502	0.0016228399	0.0029258936
+0	2	4.279954614	2.500000000	3.390000000	0.0032817049	-0.0030860905	0.0003395032
+0	3	2.500000000	2.500050506	3.390000000	-0.0043047500	-0.0037426661	0.0002411414
+1	0	3.389954614	3.129400000	3.390000000	0.0011218592	0.0034924140	-0.0010282829
+MeanForce:	0.00407938323655
+0	0	3.389954614	3.758700000	2.500000000	-0.0000218241	0.0047889356	-0.0060472963
+0	1	3.389954614	3.758700000	4.280000000	0.0002901352	0.0039273552	0.0051421234
+0	2	4.279954614	2.500000000	3.390000000	0.0023426615	-0.0015244266	0.0003063322
+0	3	2.500000000	2.500050506	3.390000000	-0.0021593078	-0.0015807723	-0.0000021906
+1	0	3.389954614	3.129400000	3.390000000	-0.0004516648	-0.0056110918	0.0006010314
+MeanForce:	0.00506796062808
+0	0	3.389954614	3.758700000	2.500000000	-0.0008797006	0.0029814165	-0.0044301089
+0	1	3.389954614	3.758700000	4.280000000	-0.0000298514	0.0029688929	0.0043381608
+0	2	4.279954614	2.500000000	3.390000000	0.0030840543	-0.0024325690	0.0003859179
+0	3	2.500000000	2.500050506	3.390000000	-0.0060737509	-0.0039020419	-0.0004650836
+1	0	3.389954614	3.129400000	3.390000000	0.0038992487	0.0003843015	0.0001711136
+MeanForce:	0.00515432988355
+0	0	3.389954614	3.758700000	2.500000000	-0.0000284183	0.0037049066	-0.0059731339
+0	1	3.389954614	3.758700000	4.280000000	-0.0006226968	0.0024897898	0.0038542470
+0	2	4.279954614	2.500000000	3.390000000	0.0020116735	-0.0016788474	-0.0004904901
+0	3	2.500000000	2.500050506	3.390000000	-0.0053140668	-0.0035563777	0.0001018163
+1	0	3.389954614	3.129400000	3.390000000	0.0039535084	-0.0009594713	0.0025075606
+MeanForce:	0.00509985000461
+0	0	3.389954614	3.758700000	2.500000000	-0.0000855624	0.0023981288	-0.0029212368
+0	1	3.389954614	3.758700000	4.280000000	-0.0003563414	0.0043651644	0.0069143757
+0	2	4.279954614	2.500000000	3.390000000	0.0043929074	-0.0031479515	0.0004704081
+0	3	2.500000000	2.500050506	3.390000000	-0.0044209305	-0.0028575733	0.0007355193
+1	0	3.389954614	3.129400000	3.390000000	0.0004699268	-0.0007577683	-0.0051990663
+MeanForce:	0.00559604100806
+0	0	3.389954614	3.758700000	2.500000000	0.0003007711	0.0023869602	-0.0033398978
+0	1	3.389954614	3.758700000	4.280000000	0.0003374891	0.0036913555	0.0053753551
+0	2	4.279954614	2.500000000	3.390000000	0.0030208578	-0.0018844577	0.0001106763
+0	3	2.500000000	2.500050506	3.390000000	-0.0061616563	-0.0045568861	0.0000796441
+1	0	3.389954614	3.129400000	3.390000000	0.0025025384	0.0003630281	-0.0022257777
+MeanForce:	0.00504813208315
+0	0	3.389954614	3.758700000	2.500000000	0.0000179366	0.0015188486	-0.0030197007
+0	1	3.389954614	3.758700000	4.280000000	0.0002172716	0.0033828488	0.0054796902
+0	2	4.279954614	2.500000000	3.390000000	0.0039034349	-0.0024601816	0.0000064612
+0	3	2.500000000	2.500050506	3.390000000	-0.0024406228	-0.0015912610	-0.0001897062
+1	0	3.389954614	3.129400000	3.390000000	-0.0016980203	-0.0008502548	-0.0022767444
+MeanForce:	0.00406443076641
+0	0	3.389954614	3.758700000	2.500000000	0.0001553524	0.0034600351	-0.0056648300
+0	1	3.389954614	3.758700000	4.280000000	0.0003484097	0.0026743864	0.0044757925
+0	2	4.279954614	2.500000000	3.390000000	0.0062554397	-0.0046827620	0.0000613037
+0	3	2.500000000	2.500050506	3.390000000	-0.0039619378	-0.0034127590	-0.0001336279
+1	0	3.389954614	3.129400000	3.390000000	-0.0027972640	0.0019610995	0.0012613618
+MeanForce:	0.00571041123928
+0	0	3.389954614	3.758700000	2.500000000	-0.0001062482	0.0025814477	-0.0033779032
+0	1	3.389954614	3.758700000	4.280000000	-0.0001946313	0.0045681342	0.0057286568
+0	2	4.279954614	2.500000000	3.390000000	0.0036754072	-0.0032688929	-0.0002696320
+0	3	2.500000000	2.500050506	3.390000000	-0.0039437777	-0.0032475150	-0.0001839279
+1	0	3.389954614	3.129400000	3.390000000	0.0005692500	-0.0006331740	-0.0018971936
+MeanForce:	0.00474001069693
+0	0	3.389954614	3.758700000	2.500000000	0.0000978028	0.0041516184	-0.0058150490
+0	1	3.389954614	3.758700000	4.280000000	-0.0000020054	0.0042586020	0.0053851317
+0	2	4.279954614	2.500000000	3.390000000	0.0051029310	-0.0028635242	-0.0003387589
+0	3	2.500000000	2.500050506	3.390000000	-0.0039978465	-0.0021531794	-0.0002377976
+1	0	3.389954614	3.129400000	3.390000000	-0.0012008818	-0.0033935168	0.0010064739
+MeanForce:	0.00563145069245
+0	0	3.389954614	3.758700000	2.500000000	0.0000198426	0.0010746533	-0.0022303433
+0	1	3.389954614	3.758700000	4.280000000	-0.0002890395	0.0019540206	0.0031744548
+0	2	4.279954614	2.500000000	3.390000000	0.0059945091	-0.0044015991	-0.0003106780
+0	3	2.500000000	2.500050506	3.390000000	-0.0060998270	-0.0042817930	0.0000016725
+1	0	3.389954614	3.129400000	3.390000000	0.0003745148	0.0056547182	-0.0006351060
+MeanForce:	0.00536266141473
+0	0	3.389954614	3.758700000	2.500000000	0.0008759309	0.0029149938	-0.0039105139
+0	1	3.389954614	3.758700000	4.280000000	0.0000263788	0.0029215569	0.0039951478
+0	2	4.279954614	2.500000000	3.390000000	0.0052833845	-0.0035012368	-0.0003890219
+0	3	2.500000000	2.500050506	3.390000000	-0.0021998880	-0.0019570224	0.0004592564
+1	0	3.389954614	3.129400000	3.390000000	-0.0039858062	-0.0003782915	-0.0001548683
+MeanForce:	0.00464835547152
+0	0	3.389954614	3.758700000	2.500000000	0.0000216840	0.0021613640	-0.0023358114
+0	1	3.389954614	3.758700000	4.280000000	0.0006215779	0.0034033111	0.0044784206
+0	2	4.279954614	2.500000000	3.390000000	0.0063249814	-0.0042312383	0.0004998858
+0	3	2.500000000	2.500050506	3.390000000	-0.0029790611	-0.0023225191	-0.0001019084
+1	0	3.389954614	3.129400000	3.390000000	-0.0039891821	0.0009890823	-0.0025405866
+MeanForce:	0.00501566313322
+0	0	3.389954614	3.758700000	2.500000000	0.0000842542	0.0034730502	-0.0053971099
+0	1	3.389954614	3.758700000	4.280000000	0.0003446398	0.0014565604	0.0013454142
+0	2	4.279954614	2.500000000	3.390000000	0.0039924555	-0.0028067206	-0.0004700819
+0	3	2.500000000	2.500050506	3.390000000	-0.0038971958	-0.0030451296	-0.0007360898
+1	0	3.389954614	3.129400000	3.390000000	-0.0005241536	0.0009222396	0.0052578675
+MeanForce:	0.00473962488846
Index: tests/Joiner/BondFragment06/pcp.speed
===================================================================
--- tests/Joiner/BondFragment06/pcp.speed	(revision 88f62988b19f6b6b102c0be34eb40d8e219b8414)
+++ tests/Joiner/BondFragment06/pcp.speed	(revision 88f62988b19f6b6b102c0be34eb40d8e219b8414)
@@ -0,0 +1,13 @@
+
+MaxG[] = nA nA nA -> N[] = nA nA nA
+LevNo   MaxG    RMaxG   MaxN    N[0]    N[1]    N[2]    RLevSStep
+0       5147691 10295381        25165824        384     256    256     0
+1       643665  1287329 3145728 192     128     128     267
+2       80442   160883  393216  96      64      64      267
+3       10074   20147   49152   48      32      32      333
+4       1264    2527    6144    24      16      16      862
+procs   proc[0] proc[1] PsiMax  PsiDoub PsiUp   PsiDown NRStep  TotalIons
+1       1       1       $Psi    $Psi+0    0+0     0+0     1       $nr
+Types	mpqc	  calc	    compute gradient	      nuc rep	      one electron gradient	      overlap gradient	      two electron gradient	        contribution	          start thread	          stop thread	        setup	    vector	      density	      evals	      extrap	      fock	        accum	        aogmat	          start thread	          stop thread	        init pmax	        local data	        setup	        sum	
+CPU	1.13	0.06	0.02	0.00	0.00	0.00	0.02	0.02	0.02	0.00	0.00	0.04	0.00	0.00	0.00	0.03	0.00	0.03	0.03	0.00	0.00	0.00	0.00	0.00	
+Wall	1.22	0.06	0.02	0.00	0.00	0.00	0.02	0.02	0.02	0.00	0.00	0.04	0.00	0.00	0.00	0.03	0.00	0.02	0.02	0.00	0.00	0.00	0.00	0.00	