Index: src/Parameters/Makefile.am
===================================================================
--- src/Parameters/Makefile.am	(revision 748fc7c0d1024191307cd0382559ca5a2f64eacb)
+++ src/Parameters/Makefile.am	(revision 95cfacdff536aaf7fb3937c5b0656feb10da531c)
@@ -39,4 +39,5 @@
 	Parameters/Validators/GenericValidators.hpp \
 	Parameters/Validators/GenericValidators_impl.hpp \
+	Parameters/Validators/getFlatListFromHierarchyOfValidators.hpp \
 	Parameters/Validators/Ops_Validator.hpp \
 	Parameters/Validators/Ops_Validator_impl.hpp \
Index: src/Parameters/Validators/Ops_Validator_impl.hpp
===================================================================
--- src/Parameters/Validators/Ops_Validator_impl.hpp	(revision 748fc7c0d1024191307cd0382559ca5a2f64eacb)
+++ src/Parameters/Validators/Ops_Validator_impl.hpp	(revision 95cfacdff536aaf7fb3937c5b0656feb10da531c)
@@ -52,4 +52,6 @@
   Validator<T> *getA(){ return a; }
   Validator<T> *getB(){ return b; }
+  const Validator<T> *getA() const { return a; }
+  const Validator<T> *getB() const { return b; }
 
 private:
@@ -90,4 +92,9 @@
   }
 
+  Validator<T> *getA(){ return a; }
+  Validator<T> *getB(){ return b; }
+  const Validator<T> *getA() const { return a; }
+  const Validator<T> *getB() const { return b; }
+
 private:
   Validator<T> *a;
@@ -126,4 +133,7 @@
   }
 
+  Validator<T> *getA(){ return a; }
+  const Validator<T> *getA() const { return a; }
+
 private:
   Validator<T> *a;
Index: src/Parameters/Validators/Specific/FileSuffixValidator.hpp
===================================================================
--- src/Parameters/Validators/Specific/FileSuffixValidator.hpp	(revision 748fc7c0d1024191307cd0382559ca5a2f64eacb)
+++ src/Parameters/Validators/Specific/FileSuffixValidator.hpp	(revision 95cfacdff536aaf7fb3937c5b0656feb10da531c)
@@ -33,4 +33,7 @@
   Validator< boost::filesystem::path >* clone() const;
 
+  const std::string & getSuffix() const
+  { return suffix; }
+
 private:
   std::string suffix;
Index: src/Parameters/Validators/Specific/ParserFileValidator.cpp
===================================================================
--- src/Parameters/Validators/Specific/ParserFileValidator.cpp	(revision 748fc7c0d1024191307cd0382559ca5a2f64eacb)
+++ src/Parameters/Validators/Specific/ParserFileValidator.cpp	(revision 95cfacdff536aaf7fb3937c5b0656feb10da531c)
@@ -72,5 +72,13 @@
 }
 
+std::vector<std::string> ParserFileValidator::getSuffixes() const
+{
+  std::vector<std::string> suffixes;
+  for (ParserTypes t = ParserTypes_begin; t < ParserTypes_end; ++ t){
+    suffixes.push_back(
+        FormatParserStorage::getInstance().getSuffixFromType(t));
+  }
+  return suffixes;
+}
 
 
-
Index: src/Parameters/Validators/Specific/ParserFileValidator.hpp
===================================================================
--- src/Parameters/Validators/Specific/ParserFileValidator.hpp	(revision 748fc7c0d1024191307cd0382559ca5a2f64eacb)
+++ src/Parameters/Validators/Specific/ParserFileValidator.hpp	(revision 95cfacdff536aaf7fb3937c5b0656feb10da531c)
@@ -27,4 +27,7 @@
   bool operator==(const Validator<boost::filesystem::path> &_instance) const;
   Validator< boost::filesystem::path >* clone() const;
+
+public:
+  std::vector<std::string> getSuffixes() const;
 };
 
Index: src/Parameters/Validators/Validator.hpp
===================================================================
--- src/Parameters/Validators/Validator.hpp	(revision 748fc7c0d1024191307cd0382559ca5a2f64eacb)
+++ src/Parameters/Validators/Validator.hpp	(revision 95cfacdff536aaf7fb3937c5b0656feb10da531c)
@@ -35,4 +35,3 @@
 };
 
-
 #endif /* VALIDATOR_HPP_ */
Index: src/Parameters/Validators/getFlatListFromHierarchyOfValidators.hpp
===================================================================
--- src/Parameters/Validators/getFlatListFromHierarchyOfValidators.hpp	(revision 95cfacdff536aaf7fb3937c5b0656feb10da531c)
+++ src/Parameters/Validators/getFlatListFromHierarchyOfValidators.hpp	(revision 95cfacdff536aaf7fb3937c5b0656feb10da531c)
@@ -0,0 +1,59 @@
+/*
+ * getFlatListFromHierarchyOfValidators.hpp
+ *
+ *  Created on: Sep 7, 2014
+ *      Author: heber
+ */
+
+#ifndef GETFLATLISTFROMHIERARCHYOFVALIDATORS_HPP_
+#define GETFLATLISTFROMHIERARCHYOFVALIDATORS_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <algorithm>
+#include <vector>
+
+#include "Parameters/Validators/Validator.hpp"
+#include "Parameters/Validators/Ops_Validator.hpp"
+
+template <class T>
+void ValidatorHierarchyClimber(
+    const Validator<T> &_validator,
+    std::vector<std::pair<const Validator<T> *, bool> > &_validators,
+    const bool _groundtruth)
+{
+  if (dynamic_cast<const And_Validator<T> *>(&_validator) != NULL) {
+    const And_Validator<T>& and_validator = dynamic_cast<const And_Validator<T>& >(_validator);
+    ValidatorHierarchyClimber(*and_validator.getA(), _validators, _groundtruth);
+    ValidatorHierarchyClimber(*and_validator.getB(), _validators, _groundtruth);
+  } else if (dynamic_cast<const Or_Validator<T> *>(&_validator) != NULL) {
+    const Or_Validator<T>& or_validator = dynamic_cast<const Or_Validator<T>& >(_validator);
+    ValidatorHierarchyClimber(*or_validator.getA(), _validators, _groundtruth);
+    ValidatorHierarchyClimber(*or_validator.getB(), _validators, _groundtruth);
+  } else if (dynamic_cast<const Not_Validator<T> *>(&_validator) != NULL) {
+    const Not_Validator<T>& not_validator = dynamic_cast<const Not_Validator<T>& >(_validator);
+    ValidatorHierarchyClimber(*not_validator.getA(), _validators, !_groundtruth);
+  } else if (dynamic_cast<const Validator<T> *>(&_validator) != NULL) {
+    const Validator<T> * Tvalidator = dynamic_cast<const Validator<T> * >(&_validator);
+    _validators.push_back( std::make_pair(Tvalidator, _groundtruth) );
+  }
+}
+
+/** Function that recursively climbs down the hierarchy of validators and adds all
+ * to a common vector as tuples of validator and a boolean, giving the ground truth
+ * of the validator, i.e. whether it was negated by a prior Not_Validator.
+ */
+template <class T>
+std::vector<std::pair<const Validator<T> *, bool> >
+getFlatListFromHierarchyOfValidators(const Validator<T> &_validator)
+{
+  std::vector<std::pair<const Validator<T> *, bool> > validators;
+  ValidatorHierarchyClimber(_validator, validators, true);
+  return validators;
+}
+
+
+#endif /* GETFLATLISTFROMHIERARCHYOFVALIDATORS_HPP_ */